Ruby - Bug #20149

Fix memory leak in IPSocket rb_getaddrinfo
01/04/2024 08:08 PM - HParker (Adam Hess)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport:

3.0: DONTNEED, 3.1: DONTNEED, 3.2:
DONTNEED, 3.3: DONE

Description
PR: https://github.com/ruby/ruby/pull/9413

Fixes a memory leak pthread_attr is created, but never cleaned up
require 'socket'

10.times do
10_000.times do
IPSocket.getaddress ("localhost")
end

puts “ps -o rss= -p #{$$}°
end

before:

26744
33400
39928
46328
53240
59640
66168
72696
79352
85880

after:

20864
20864
20864
20864
20864
20992
20992
20992
20992
21120

This likely needs a backport to Ruby 3.3 series.

Associated revisions

Revision 6aacbd690ccde53f9b97c6673482cb11df3f2955 - 01/04/2024 11:56 PM - HParker (Adam Hess)

Free pthread_attr after setting up the thread

[bug #20149]

Revision 6aacbd690ccde53f9b97c6673482ch11df3f2955 - 01/04/2024 11:56 PM - HParker (Adam Hess)

Free pthread_attr after setting up the thread

06/11/2025

1/2



https://github.com/ruby/ruby/pull/9413

[bug #20149]

Revision 6aacbd69 - 01/04/2024 11:56 PM - HParker (Adam Hess)
Free pthread_attr after setting up the thread

[bug #20149]

Revision 2886564279dff87a6¢c293f6e80436eb2b309967e - 02/01/2024 01:39 AM - naruse (Yui NARUSE)
merge revision(s) 6aacbd690ccde53f9b97¢c6673482cb11df3f2955: [Backport #20149]

Free pthread_attr after setting up the thread
[bug #20149]

ext/socket/raddrinfo.c | 12 +++++++++++-
1 file changed, 11 insertions(+), 1 deletion(-)

Revision 2886564279dff87a6c29316e80436eb2b309967¢ - 02/01/2024 01:39 AM - naruse (Yui NARUSE)
merge revision(s) 6aacbd690ccde53f9b97c6673482cb11df3f2955: [Backport #20149]

Free pthread_attr after setting up the thread

[bug #20149]

ext/socket/raddrinfo.c | 12 +++++++++++-
1 file changed, 11 insertions(+), 1 deletion(-)

Revision 28865642 - 02/01/2024 01:39 AM - naruse (Yui NARUSE)

merge revision(s) 6aacbd690ccde53f9b97c6673482cb11df3f2955: [Backport #20149]
Free pthread_attr after setting up the thread

[bug #20149]

ext/socket/raddrinfo.c | 12 +++++++++++-
1 file changed, 11 insertions(+), 1 deletion(-)

History

#1 - 01/04/2024 08:28 PM - peterzhu2118 (Peter Zhu)

- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN to 3.0: DONTNEED, 3.1: DONTNEED, 3.2:
DONTNEED, 3.3: REQUIRED

#2 - 01/08/2024 11:55 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed

#3 - 02/01/2024 04:11 AM - naruse (Yui NARUSE)
- Backport changed from 3.0: DONTNEED, 3.1: DONTNEED, 3.2: DONTNEED, 3.3: REQUIRED to 3.0: DONTNEED, 3.1: DONTNEED, 3.2:
DONTNEED, 3.3: DONE

ruby_3_3 2886564279dff87a6c293f6e80436eb2b309967e merged revision(s) 6aacbd690ccde53f9b97¢c6673482cb11df3f2955.
